=== lib60870-C/examples/CMakeLists.txt ===
add_subdirectory(cs101_master_balanced)
add_subdirectory(cs101_master_unbalanced)
add_subdirectory(cs101_slave)
add_subdirectory(cs101_slave_files)
add_subdirectory(cs104_client)
add_subdirectory(cs104_client_async)
add_subdirectory(cs104_server)
add_subdirectory(cs104_server_no_threads)
add_subdirectory(cs104_server_files)
add_subdirectory(cs104_redundancy_server)
add_subdirectory(multi_client_server)

if (WITH_MBEDTLS)
add_subdirectory(tls_client)
add_subdirectory(tls_server)
endif (WITH_MBEDTLS)
