=== debian/changelog ===
lib60870 (2.3.2-1.1) unstable; urgency=medium

  * Non-maintainer upload
  * Drop optional TLS support (Closes: #1075864)

 -- Bastian Germann <bage@debian.org>  Wed, 13 Nov 2024 20:58:04 +0000

lib60870 (2.3.2-1) unstable; urgency=medium

  * Initial release (Closes: #1041565)

 -- Yangfl <mmyangfl@gmail.com>  Wed, 14 Feb 2024 15:50:12 +0800
