=== debian/control ===
Source: lib60870
Priority: optional
Maintainer: Yangfl <mmyangfl@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Section: libs
Homepage: https://www.mz-automation.de/iec60870-5-101-104-c-source-code-library/
Vcs-Git: https://salsa.debian.org/yangfl-guest/lib60870.git
Vcs-Browser: https://salsa.debian.org/yangfl-guest/lib60870

Package: liblib60870-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblib60870-2 (= ${binary:Version}), ${misc:Depends}
Description: library for IEC 60870-5 based protocols in C (development files)
 lib60870 is a feature rich and field proven implementation of the IEC
 60870-5-101/104 protocol for client (master station) and server (slave or
 controlled station). The library implements all data types of the IEC
 60870-5-101/104 specifications.
 .
 This package contains the header files for lib608701.

Package: liblib60870-2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for IEC 60870-5 based protocols in C
 lib60870 is a feature rich and field proven implementation of the IEC
 60870-5-101/104 protocol for client (master station) and server (slave or
 controlled station). The library implements all data types of the IEC
 60870-5-101/104 specifications.
 .
 Features:
   * support for all application layer message types
   * master and slave
   * balanced and unbalanced link layers (for CS 101 serial communication)
   * client/server for CS 104 TCP/IP communication
   * CS 104 redundancy group support
   * CS101 slave/CS104 server: file service support
   * Supports most TLS features required by IEC 62351-3 (third party code
     mbedtls required)
   * portable C99 code
