=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND =


%:
	dh $@ --buildsystem=cmake --sourcedirectory=lib60870-C

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_MBEDTLS=OFF
