## lib60870 2.3.4

=== lib60870-C/CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 set(LIB_VERSION_MAJOR "2")
 set(LIB_VERSION_MINOR "3")
-set(LIB_VERSION_PATCH "2")
+set(LIB_VERSION_PATCH "4")
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/third_party/cmake/modules/")
 
@@ -22,7 +22,6 @@
 
 # feature checks
 include(CheckLibraryExists)
-check_library_exists(rt clock_gettime "time.h" CONFIG_SYSTEM_HAS_CLOCK_GETTIME)
 
 # check if we are on a little or a big endian
 include (TestBigEndian)
@@ -38,8 +37,12 @@
 
 if(EXISTS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28)
 set(WITH_MBEDTLS 1)
+message("mbedtls 2.28 found")
+ELSEIF(EXISTS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-3.6)
+set(WITH_MBEDTLS3 1)
+message("mbedtls 3.6 found")
 else()
-message("NOTE: mbedtls 2.28 is required for TLS support!")
+message("NOTE: mbedtls 2.28 or 3.6 is required for TLS support!")
 endif(EXISTS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28)
 
 endif(BUILD_HAL)
@@ -66,6 +69,19 @@
 
 endif(WITH_MBEDTLS)
 
+if(WITH_MBEDTLS3)
+include_directories(
+	${CMAKE_CURRENT_LIST_DIR}/src/hal/tls/mbedtls3
+	${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-3.6/include
+)
+
+file(GLOB tls_SRCS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-3.6/library/*.c)
+
+add_definitions(-DCONFIG_CS104_SUPPORT_TLS=1)
+add_definitions(-DMBEDTLS_CONFIG_FILE="mbedtls_config.h")
+
+endif(WITH_MBEDTLS3)
+
 
 set(API_HEADERS 
 	${CMAKE_CURRENT_LIST_DIR}/src/hal/inc/hal_time.h 
@@ -74,6 +90,7 @@
 	${CMAKE_CURRENT_LIST_DIR}/src/hal/inc/hal_serial.h
 	${CMAKE_CURRENT_LIST_DIR}/src/hal/inc/hal_base.h
 	${CMAKE_CURRENT_LIST_DIR}/src/hal/inc/tls_config.h
+	${CMAKE_CURRENT_LIST_DIR}/src/hal/inc/tls_ciphers.h
 	${CMAKE_CURRENT_LIST_DIR}/src/common/inc/linked_list.h
 	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/cs101_master.h
 	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/cs101_slave.h
@@ -84,6 +101,7 @@
 	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/cs101_information_objects.h
 	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/cs104_connection.h
 	${CMAKE_CURRENT_LIST_DIR}/src/inc/api/link_layer_parameters.h
+	${CMAKE_CURRENT_LIST_DIR}/src/file-service/cs101_file_service.h
 )
 
 include(CheckCCompilerFlag)
