=== debian/changelog ===
lib60870 (2.3.4-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.7.2

 -- Yangfl <mmyangfl@gmail.com>  Wed, 12 Mar 2025 10:57:01 +0800
