=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,3 @@
 
 %:
 	dh $@ --buildsystem=cmake --sourcedirectory=lib60870-C
-
-override_dh_auto_configure:
-	dh_auto_configure -- -DWITH_MBEDTLS=OFF
