## lib60870 2.3.6

=== lib60870-C/CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 set(LIB_VERSION_MAJOR "2")
 set(LIB_VERSION_MINOR "3")
-set(LIB_VERSION_PATCH "4")
+set(LIB_VERSION_PATCH "5")
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/third_party/cmake/modules/")
