=== lib60870-C/Makefile ===
--- 
+++ 
@@ -43,6 +43,15 @@
 CFLAGS += -D'CONFIG_CS104_SUPPORT_TLS=1'
 endif
 
+ifdef WITH_MBEDTLS3
+LIB_SOURCE_DIRS += dependencies/mbedtls-3.6/library
+LIB_SOURCE_DIRS += src/hal/tls/mbedtls3
+LIB_INCLUDE_DIRS += src/hal/tls/mbedtls3
+LIB_INCLUDE_DIRS += dependencies/mbedtls-3.6/include
+CFLAGS += -D'MBEDTLS_CONFIG_FILE="mbedtls_config.h"'
+CFLAGS += -D'CONFIG_CS104_SUPPORT_TLS=1'
+endif
+
 endif
 
 LIB_INCLUDE_DIRS += config
@@ -74,6 +83,8 @@
 LIB_API_HEADER_FILES += src/inc/api/iec60870_slave.h
 LIB_API_HEADER_FILES += src/inc/api/link_layer_parameters.h
 LIB_API_HEADER_FILES += src/hal/inc/tls_config.h
+LIB_API_HEADER_FILES += src/hal/inc/tls_ciphers.h
+LIB_API_HEADER_FILES += src/file-service/cs101_file_service.h
 
 LIB_TEST_SOURCES = tests/all_tests.c
 LIB_TEST_SOURCES += tests/unity/unity.c
