=== debian/changelog ===
lib60870 (2.3.6-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Tue, 19 Aug 2025 14:25:01 +0800
