=== debian/control ===
--- 
+++ 
@@ -4,8 +4,10 @@
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
+ pkgconf,
+ libmbedtls-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://www.mz-automation.de/iec60870-5-101-104-c-source-code-library/
 Vcs-Git: https://salsa.debian.org/yangfl-guest/lib60870.git
