=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%lib60870-$1.tar.gz%" \
   https://github.com/mz-automation/lib60870/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
