## lib60870 2.4.0

=== lib60870-C/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.0...3.31)
 
 # automagically detect if we should cross-compile
 if(DEFINED ENV{TOOLCHAIN})
@@ -11,8 +11,8 @@
 ENABLE_TESTING()
 
 set(LIB_VERSION_MAJOR "2")
-set(LIB_VERSION_MINOR "3")
-set(LIB_VERSION_PATCH "5")
+set(LIB_VERSION_MINOR "4")
+set(LIB_VERSION_PATCH "0")
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/third_party/cmake/modules/")
 
@@ -35,15 +35,26 @@
 
 if(BUILD_HAL)
 
-if(EXISTS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28)
-set(WITH_MBEDTLS 1)
-message("mbedtls 2.28 found")
-ELSEIF(EXISTS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-3.6)
-set(WITH_MBEDTLS3 1)
-message("mbedtls 3.6 found")
+## Detect mbedtls dependency folders. Accept folder names with patch/minor suffixes
+set(MBEDTLS_DIR "")
+file(GLOB MBEDTLS_2_28_CANDIDATES "${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28*")
+file(GLOB MBEDTLS_3_6_CANDIDATES "${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-3.6*")
+
+if(MBEDTLS_2_28_CANDIDATES)
+	list(GET MBEDTLS_2_28_CANDIDATES 0 MBEDTLS_DIR)
+	set(WITH_MBEDTLS 1)
+	set(WITH_SEC_AUTH 1)
+	add_definitions(-DWITH_MBEDTLS=1)
+	message("mbedtls 2.28 found: ${MBEDTLS_DIR}")
+elseif(MBEDTLS_3_6_CANDIDATES)
+	list(GET MBEDTLS_3_6_CANDIDATES 0 MBEDTLS_DIR)
+	set(WITH_MBEDTLS3 1)
+	set(WITH_SEC_AUTH 1)
+	add_definitions(-DWITH_MBEDTLS3=1)
+	message("mbedtls 3.6 found: ${MBEDTLS_DIR}")
 else()
-message("NOTE: mbedtls 2.28 or 3.6 is required for TLS support!")
-endif(EXISTS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28)
+	message("NOTE: mbedtls 2.28 or 3.6 is required for TLS support and secure authentication!")
+endif()
 
 endif(BUILD_HAL)
 
@@ -56,31 +67,25 @@
     ${CMAKE_CURRENT_LIST_DIR}/src/hal/inc
 )
 
-if(WITH_MBEDTLS)
-include_directories(
-    ${CMAKE_CURRENT_LIST_DIR}/src/hal/tls/mbedtls
-    ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28/include
-)
+if(MBEDTLS_DIR)
+	# choose appropriate HAL adapter (mbedtls vs mbedtls3)
+	if(WITH_MBEDTLS3)
+		include_directories(
+			${CMAKE_CURRENT_LIST_DIR}/src/hal/tls/mbedtls3
+			${MBEDTLS_DIR}/include
+		)
+		file(GLOB tls_SRCS ${MBEDTLS_DIR}/library/*.c)
+	else()
+		include_directories(
+			${CMAKE_CURRENT_LIST_DIR}/src/hal/tls/mbedtls
+			${MBEDTLS_DIR}/include
+		)
+		file(GLOB tls_SRCS ${MBEDTLS_DIR}/library/*.c)
+	endif()
 
-file(GLOB tls_SRCS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-2.28/library/*.c)
-
-add_definitions(-DCONFIG_CS104_SUPPORT_TLS=1)
-add_definitions(-DMBEDTLS_CONFIG_FILE="mbedtls_config.h")
-
-endif(WITH_MBEDTLS)
-
-if(WITH_MBEDTLS3)
-include_directories(
-	${CMAKE_CURRENT_LIST_DIR}/src/hal/tls/mbedtls3
-	${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-3.6/include
-)
-
-file(GLOB tls_SRCS ${CMAKE_CURRENT_LIST_DIR}/dependencies/mbedtls-3.6/library/*.c)
-
-add_definitions(-DCONFIG_CS104_SUPPORT_TLS=1)
-add_definitions(-DMBEDTLS_CONFIG_FILE="mbedtls_config.h")
-
-endif(WITH_MBEDTLS3)
+	add_definitions(-DCONFIG_CS104_SUPPORT_TLS=1)
+	add_definitions(-DMBEDTLS_CONFIG_FILE="mbedtls_config.h")
+endif()
 
 
 set(API_HEADERS 
@@ -114,6 +119,16 @@
 # write the detected stuff to this file
 # configure_file(config/lib60870_config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config/lib60870_config.h)
 
+add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/src)
+
+if(EXISTS ${CMAKE_CURRENT_LIST_DIR}/modules/sec-auth)
+
+add_compile_definitions(SEC_AUTH_60870_5_7)
+
+include(${CMAKE_CURRENT_LIST_DIR}/modules/sec-auth/CMakeLists.txt)
+
+endif(EXISTS ${CMAKE_CURRENT_LIST_DIR}/modules/sec-auth)
+
 if(BUILD_EXAMPLES)
 	add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/examples)
 endif(BUILD_EXAMPLES)
@@ -121,8 +136,6 @@
 if(BUILD_TESTS)
 	add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/tests)
 endif(BUILD_TESTS)
-
-add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/src)
 
 INSTALL(FILES ${API_HEADERS} DESTINATION include/lib60870 COMPONENT Development)
