=== lib60870-C/examples/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,7 @@
 add_subdirectory(cs101_slave_files)
 add_subdirectory(cs104_client)
 add_subdirectory(cs104_client_async)
+add_subdirectory(cs104_client_no_threads)
 add_subdirectory(cs104_server)
 add_subdirectory(cs104_server_no_threads)
 add_subdirectory(cs104_server_files)
