=== lib60870-C/src/CMakeLists.txt ===
--- 
+++ 
@@ -58,6 +58,14 @@
 )
 
 endif (BUILD_HAL)
+
+if(EXISTS ${CMAKE_CURRENT_LIST_DIR}/../modules/sec-auth)
+
+include(${CMAKE_CURRENT_LIST_DIR}/../modules/sec-auth/CMakeLists_src.txt)
+
+add_compile_definitions(SEC_AUTH_60870_5_7)
+
+endif(EXISTS ${CMAKE_CURRENT_LIST_DIR}/../modules/sec-auth)
 
 IF(WIN32)
