=== lib60870-C/examples/cs104_client_no_threads/CMakeLists.txt ===
add_executable(cs104_client_no_threads cs104_client_no_threads.c)

target_link_libraries(cs104_client_no_threads PRIVATE lib60870)
