=== debian/changelog ===
lib60870 (2.4.0-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.7.3

 -- Yangfl <mmyangfl@gmail.com>  Wed, 25 Feb 2026 03:20:10 +0800

lib60870 (2.3.6-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113105)

 -- Adrian Bunk <bunk@debian.org>  Sat, 08 Nov 2025 15:22:02 +0200
