=== debian/control ===
--- 
+++ 
@@ -1,14 +1,12 @@
 Source: lib60870
-Priority: optional
+Section: libs
 Maintainer: Yangfl <mmyangfl@gmail.com>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
  pkgconf,
  libmbedtls-dev,
-Rules-Requires-Root: no
-Standards-Version: 4.7.2
-Section: libs
+Standards-Version: 4.7.3
 Homepage: https://www.mz-automation.de/iec60870-5-101-104-c-source-code-library/
 Vcs-Git: https://salsa.debian.org/yangfl-guest/lib60870.git
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/lib60870
