=== debian/watch ===
Version: 5
Template: Github
Owner: mz-automation
Project: lib60870
